datablock AudioProfile(Lightning0) { filename = "./Lightning_1.wav"; description = AudioClosest3d; preload = 0; };
datablock AudioProfile(Lightning1 : Lightning0) { filename = "./Lightning_5.wav"; };
datablock AudioProfile(Lightning2 : Lightning0) { filename = "./Lightning_A1.wav"; };

function thunderclap(%pos)
{
	%rand = getRandom(0,2);
	%data = ("Lightning"@%rand).getID();
	for(%i=0;%i<ClientGroup.getCount();%i++)
		if(isObject(%obj = (%cl = ClientGroup.getObject(%i)).getControlObject()))
			%cl.schedule(vectorDist(%pos, getWords(%obj.getPosition(), 0, 1)) / 0.880, "play2D", %data);
}

function lightningStrike(%pos, %start, %lighting, %sunPos)
{
	%dist = vectorDist(%start, getSimTime());
	if(%dist >= 300)
	{
		servercmdEnvGui_SetVar(LightningMaster, "DirectLightColor", getField(%lighting, 0));
		servercmdEnvGui_SetVar(LightningMaster, "AmbientLightColor", getField(%lighting, 1));
		servercmdEnvGui_SetVar(LightningMaster, "ShadowColor", getField(%lighting, 2));
		servercmdEnvGui_SetVar(LightningMaster, "SunAzimuth", getField(%lighting, 3));
		servercmdEnvGui_SetVar(LightningMaster, "SunElevation", getField(%lighting, 4));
		return;
	}
	else
	{
		if(%dist <= 100 || %dist >= 200)
		{
			if($VengefulLightning)
			{
				%type = $TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType;
				%tol = getRandom(50, 5) / 1000;
				while(vectorDist("0 0 -1", %vect) >= %tol)
					%vect = vectorNormalize((getRandom(-2500, 2500) / 10000) SPC (getRandom(-2500, 2500) / 10000) SPC (getRandom(-12500, -7500) / 10000));
				%hit = containerRaycast(vectorAdd(%pos, "0 0 500"), vectorAdd(%pos, vectorScale(%vect, 512)), %type);
				if(isObject(%hit))
				{
					switch$(%hit.getClassName())
					{
						case "AIPlayer":
							%hit.kill();
						case "fxDtsBrick":
							%hit.killBrick();
						case "Player":
							%hit.kill();
					}
					for(%i=0;%i<4;%i++)
					{
						new Projectile()
						{
							datablock = GunProjectile;
							initialPosition = vectorAdd(getWords(%hit, 1, 3), vectorScale(%vect, -%i));
							initialVelocity = "0 0 0";
						}.explode();
					}
				}
			}
			servercmdEnvGui_SetVar(LightningMaster, "DirectLightColor", "1 1 1");
			servercmdEnvGui_SetVar(LightningMaster, "AmbientLightColor", "1 1 1");
			if(vectorLen("0.6 0.6 0.6") > vectorLen(%shad))
				servercmdEnvGui_SetVar(LightningMaster, "ShadowColor", "0.6 0.6 0.6");
			servercmdEnvGui_SetVar(LightningMaster, "SunAzimuth", getField(%sunPos, 0));
			servercmdEnvGui_SetVar(LightningMaster, "SunElevation", getField(%sunPos, 1));
		}
		else
		{
			servercmdEnvGui_SetVar(LightningMaster, "DirectLightColor", getField(%lighting, 0));
			servercmdEnvGui_SetVar(LightningMaster, "AmbientLightColor", getField(%lighting, 1));
			servercmdEnvGui_SetVar(LightningMaster, "ShadowColor", getField(%lighting, 2));
			servercmdEnvGui_SetVar(LightningMaster, "SunAzimuth", getField(%lighting, 3));
			servercmdEnvGui_SetVar(LightningMaster, "SunElevation", getField(%lighting, 4));
		}
		schedule(16, 0, "lightningStrike", %pos, %start, %lighting, %sunPos);
	}
}

function createLightning(%pos)
{
	cancel($LightningSched);
	if(!isObject(LightningMaster))
		new AIConnection(LightningMaster) { isAdmin = 1; };
	lightningStrike(%pos, getSimTime(), $EnvGuiServer::DirectLightColor TAB
						$EnvGuiServer::AmbientLightColor TAB
						$EnvGuiServer::ShadowColor TAB
						$EnvGuiServer::SunAzimuth TAB
						$EnvGuiServer::SunElevation,
						(getRandom(0, 35999) / 100) TAB (getRandom(1500, 4500) / 100));
	thunderclap(%pos);
	%pos = getRandom(-5000, 5000) SPC getRandom(-5000, 5000);
	if($VengefulLightning)
	{
		for(%i=0;%i<ClientGroup.getCount();%i++)
			if(isObject(%pl = (%cl = ClientGroup.getObject(%i)).player) && %pl.getState() !$= "DEAD")
				%item[-1+%items++] = %pl.position;
		if(%items != 0)
			%pos = %item[getRandom(0, %items - 1)];
	}
	$LightningSched = schedule(getRandom(5, 30) * 1000, 0, "createLightning", %pos);
}